#include <cstring>
#include <cstdlib>
#include <cstdio>

#include "myspell.hxx"

extern char * mystrdup(const char * s);

using namespace std;

void load_privdic(char * filename, MySpell * pMS) 
{
	char buf[8192];
	char * w;
	
	fprintf(stdout,"%s\n",filename);
	FILE *dic = fopen(filename,"r");
	if (dic) {
		while(fgets(buf,8191,dic)) {
			*(buf + strlen(buf) - 1) = '\0';
			fprintf(stdout,"%s\n",buf);
			pMS->spell("PuT");
			if ((strlen(buf)>4) && (w=strstr(buf+1,"PuT"))!=NULL) {
				*w='\0';
				pMS->spell(buf);
				pMS->spell(w+3);				
			} else {
				pMS->spell(buf);
				pMS->spell(buf);
			}
		}
	}
}

int main(int argc, char** argv)
{
//	char * af;
//	char * df;
//	char * wtc;
	char *privdicname;
	FILE* privdic;
	int TeXMODE=0;
	char buf[8192];

  /* first parse the command line options */
  /* arg1 - affix file, arg2 dictionary file, arg3 - file of words to check */

/*
  if (argv[1]) {
       af = mystrdup(argv[1]);
  } else {
    fprintf(stderr,"correct syntax is:\n"); 
    fprintf(stderr,"example affix_file dictionary_file file_of_words_to_check\n");
    exit(1);
  }
  if (argv[2]) {
       df = mystrdup(argv[2]);
  } else {
    fprintf(stderr,"correct syntax is:\n"); 
    fprintf(stderr,"example affix_file dictionary_file file_of_words_to_check\n");
    exit(1);
  }
  if (argv[3]) {
       wtc = mystrdup(argv[3]);
  } else {
    fprintf(stderr,"correct syntax is:\n"); 
    fprintf(stderr,"example affix_file dictionary_file file_of_words_to_check\n");
    exit(1);
  }

*/

	MySpell * pMS = new MySpell(
		"/usr/lib/mispell/hu_HU.aff",
		"/usr/lib/mispell/hu_HU.dic");

	/* open the private dictionary */
	strcpy(buf,getenv("HOME"));
	strcat(buf,"/.ispell_magyar");
	load_privdic(buf, pMS);
	load_privdic("./.ispell_magyar", pMS);

    fprintf(stdout,"@(#) MIspell Version 0.4 06/17/02\n");
    fflush(stdout);
    int k;
    int dp;
    char * token;
    int pos;
    char prevnochar='\0';

    char * try_string = pMS->get_try_string();
    int try_string_len = strlen(try_string);

//    fprintf(stdout,"%s\n",pMS->get_try_string());
    while(fgets(buf,8191,stdin)) {
      k = strlen(buf);
      *(buf + k - 1) = '\0';
      if (TESTAFF("*@#~+-!%",buf[0],8)) { // `^' handled later 
        if (buf[0]=='+') TeXMODE=1;
        if (buf[0]=='-') TeXMODE=0;
	continue;      
      }
      if (buf[0] == '^') pos = 1; // ^ ispell command char
      else pos = 0;
      token = buf+pos;
      for (int i=pos; i<k; i++) {
        if (! TESTAFF(try_string, buf[i], try_string_len)) {
	  if ((buf+i-token==0) || // nonchar sequence
	      ((TeXMODE==1) && (prevnochar=='\\'))) {
	    prevnochar = buf[i];
	    token = buf+i+1;
	    continue;
	  }
	  prevnochar = buf[i];
	  buf[i] = '\0';
          dp = pMS->spell(token);
          if (dp) {
            fprintf(stdout,"*\n");
	    fflush(stdout);
          } else {
            char ** wlst;
            int ns = pMS->suggest(&wlst,token);
	    if (ns==0) {
	      fprintf(stdout,"# %s %d",token,token-buf);
	    } else {
	      fprintf(stdout,"& %s %d %d: %s",token,ns,token-buf,wlst[0]);
	    }
            for (int i=1; i < ns; i++) {
              fprintf(stdout,", %s",wlst[i]);
              free(wlst[i]);
            }
            fprintf(stdout,"\n");
	    fflush(stdout);
            free(wlst);
          }
	  token = buf+i+1;
	}
      }
      fprintf(stdout,"\n");
      fflush(stdout);
    }
    if (try_string) free(try_string);
    delete pMS;
    return 0;
}

